#!/bin/sh
#
# cvs-build - script for building linuxconf module package from CVS
#
# It will first export package source from cvs server, 
# and then build the RPM package on the local system.
#
### Args:
#
# $1 = cvs module
# $2 = cvs tag
#
### Available tags:
#
# RELEASE : latest public release source
# HEAD    : latest development source
#
### Availabe modules:
#
# ldapconf
# isdnadmin
# tpconf
# htmlplus
# tobot
#
### Local config
BUILD_ROOT=/tmp/cvs-build
DEVEL_ROOT=/usr/local/cvs-devel

### CVS config
CVS_USER=guest
CVS_SERVER=cvs.terminator.net
CVS_SERVER_ROOT=/vhome/cvs/root/terminator
CVS_PROTOCOL=:pserver:
CVS_COMPRESS="-z 3"

### Usage
if [ -z $1 ] ; then
echo "usage: $0 [modulename] <tag>"
exit
fi

### Setup
MOD_NAME=$1
if [ -z $2 ] ; then CVS_TAG=HEAD ; else CVS_TAG=$2 ; fi
if [ -z $3 ] ; then MOD_VERSION=n/a ; else MOD_VERSION=$3 ; fi
#if [ -z $4 ] ; then ACTION='build' ; else ACTION='dist' ; fi

CVS_ROOT=$CVS_PROTOCOL$CVS_USER@$CVS_SERVER:$CVS_SERVER_ROOT
BUILD_DIR=$BUILD_ROOT/$CVS_MODULE

### Login
#cvs -d CVS_ROOT login

### Export
mkdir -p $BUILD_ROOT
cd $BUILD_ROOT
rm -rf $MOD_NAME
cvs $CVS_COMPRESS -d $CVS_ROOT export -r $CVS_TAG $MOD_NAME
cd -

### Build
echo -------------------------------------
echo Building RPM packages from CVS source
echo Server: $CVS_SERVER
echo Module: $MOD_NAME
echo Version: $MOD_VERSION
echo Tag: $CVS_TAG
echo -------------------------------------
cd $BUILD_DIR
RET='make buildrpm'
cd -

if [ ! -z $4 ] ; then
echo Distribute: Tag the current source file versions
cvs rtag -F RELEASE ldapconf
fi

### Done!
if $RET ; then

echo
echo "RPM packages for module $MODULE ready to install! (in /usr/src/redhat)"

else

echo
echo "RPM build failed, something wrong!"

fi


