#ifndef profiles_h
#define profiles_h

#include <userconf.h>

class CONFDB;
class USERS;

class PROFILE: public ARRAY_OBJ{
public:
	SSTRING id;
	CONFDB *data;
	CONFIG_FILE *file;
	/*~PROTOBEG~ PROFILE */
public:
	PROFILE (void);
	void init (void);
	void reset (void);
	int setfile (const char *path);
	~PROFILE (void);
	/*~PROTOEND~ PROFILE */
};

class PROFILES: public ARRAY {
public:
	SSTRING path;
	SSTRING id;
	PROFILE profile;

	/*~PROTOBEG~ PROFILES */
public:
	PROFILES (const char *path);
	PROFILES (const char *path, const char *id);
	PROFILES (void);
	int add (CONFDB *db);
	int add (const char *id);
	int del (void);
	int dia_list (DIALOG&dia, SSTRINGS&tb);
	int dia_select (void);
	CONFDB *get (const char *id);
	int get_list (SSTRINGS&lst);
	void reset (void);
	int setpath (const char *id);
	void setup_priv (PRIVILEGES&priv_tb,
		 const char *section);
	int use (const char *id);
	~PROFILES (void);
	/*~PROTOEND~ PROFILES */
};

#define _TLMP_profiles_dia_admin

struct _F_profiles_dia_admin{
	#define _F_profiles_dia_admin_editone(x) void x editone (const char *id)
	virtual _F_profiles_dia_admin_editone( )=0;
};


#endif






