
# $Id: ldap.conf.nss,v 1.1 1999/07/24 19:25:53 stein Exp $

# This is the configuration file for the LDAP nameservice
# switch library and the LDAP PAM module.

# To contact the developers, mail support@padl.com.

# If the host and base aren't here, then the DNS RR
# _ldap._tcp.<defaultdomain>. will be resolved. <defaultdomain>
# will be mapped to a distinguished name and the target host
# will be used as the server.

# Your LDAP server. Must be resolvable without using LDAP.
host	demo.nett.org

# The distinguished name of the search base.
base	dc=demo,dc=nett,dc=nett

# The LDAP version to use (defaults to 2)
# ldap_version 3

# The distinguished name to bind to the server with.
# Optional: default is to bind anonymously.
# binddn cn=manager,dc=padl,dc=com

# The credentials to bind with.
# Optional: default is no credential.
# bindpw secret

# The port.
# Optional: default is 389.
# port 389

# The search scope.
# scope sub
# scope one
# scope base

# The following options are specific to nss_ldap.

# The hashing algorith your libc uses.
# Optional: default is des
# crypt md5
# crypt sha
# crypt des

# The following options are specific to pam_ldap.

# Filter to AND with uid=%s
# pam_filter objectclass=account

# The user ID attribute (defaults to uid)
# pam_login_attribute uid

# Search the root DSE for the password policy (works
# with Netscape Directory Server)
# pam_lookup_policy yes

# Group to enforce membership of
# pam_groupdn cn=PAM,ou=Groups,dc=padl,dc=com

# Group member attribute
# pam_member_attribute uniquemember

# Hash password locally; required for University of
# Michigan LDAP server, and works with Netscape
# Directory Server if you're using the UNIX-Crypt
# hash mechanism and not using the NT Synchronization
# service.
# pam_crypt local

